<template>
<!-- <button @click="sendMessage">aaaaaaaaaaaaaaa</button> -->
  <router-view></router-view>
  <Footer></Footer>
</template>

<script>
import JWT from "vue-jwt-decode";
import { createToast } from "mosha-vue-toastify";
import { Client } from '@stomp/stompjs';
import Footer from "./components/Footer.vue"

export default {
  name: 'App',
  data() {return {
    stompClient: null
  }},
  components: {
    Footer
  },
  methods: {
    logout() {
      localStorage.removeItem('token');
      this.$router.push('/login');
    },
    connectSocket() {

      this.stompClient = new Client({
        brokerURL: 'ws://localhost:3000/ws',
        connectHeaders: {
          'X-Authorization': localStorage.getItem("token")
        },
        debug: function (str) {
          console.log(str);
        },
        reconnectDelay: 5000,
        heartbeatIncoming: 4000,
        heartbeatOutgoing: 4000,
      });

      this.stompClient.onConnect = this.onConnected;

      this.stompClient.onStompError = this.onError;

      this.stompClient.activate();
      
    },
    onConnected() {
      console.log("connected to web sockets");
      this.stompClient.subscribe('/topic/publicChatRoom', this.onMessageReceived);

    // Tell your username to the server
      this.stompClient.publish({
        destination: "/app/chat.addUser",
        body: JSON.stringify({sender: this.username, type: 'JOIN'})
      })
    },
    onError(error) {
      console.log("bruhhhh");
      console.log(error);
    },
    onMessageReceived(payload) {
        let message = JSON.parse(payload.body);
        if(message.type && message.type === "JOIN" && message.sender != this.username) {
          this.toast(`${message.sender} is connected`, 'default', 2000);
        }
        console.log('message');
        console.log(message);
        console.log('message');
    }
  },
  async beforeCreate() {
      if (localStorage.getItem("token")) {
        let userData = await JWT.decode(localStorage.getItem("token"));
        await this.$store.commit("setUsername", userData.username);
        await this.$store.commit("setMail", userData.sub);
        fetch(`http://localhost:3000/api/userData`,
          {
            method: 'POST',
            headers: {
              'Content-Type': 'application/json',
              'Access-Control-Allow-Origin': '*',
              'Authorization': `Bearer ${localStorage.getItem('token')}`
            },
            body: JSON.stringify({
              mail: userData.sub
            })
          })
          .then(response => response.json())
          .then(data => {
              if(data.status && data.status === 200){
                this.$store.commit('getUserData', data.data);
                this.$store.commit("setProfilePicture", data.data.profilePicture);
                let fullDateCreate = data.data.dateCreate.split(" ");
                let hourCreate = fullDateCreate[1].split(":");
                let datecreate = fullDateCreate[0].split("-");
                hourCreate = hourCreate[0] + "h" + hourCreate[1];
                datecreate = `${datecreate[2]}/${datecreate[1]}/${datecreate[0]}`;
                this.$store.commit('setDateCreate', [datecreate, hourCreate]);
              } else {
                this.toast("Your session has expired", 'danger');
                this.logout();
              }
          })
      }
  },
  computed: {
      username() {
        return this.$store.state.username;
      }
  },
  setup() {
    const toast = (message, type, timer) => {
      createToast(message, {
        position: "top-right",
        timeout: timer,
        type: type,
        showIcon: true,
      });
    };

    return { 
        toast
      };
    
  },
  mounted() {
    if(localStorage.getItem("token")){
      this.connectSocket();
    }
  }
}
</script>

<style>

@font-face {
    font-family: 'Oswald';
    src: url('./assets/fonts/oswald/Oswald-Regular.ttf');
}
@font-face {
    font-family: 'Oswald-Bold';
    src: url('./assets/fonts/oswald/Oswald-Bold.ttf');
}
@font-face {
    font-family: 'Oswald-Light';
    src: url('./assets/fonts/oswald/Oswald-Light.ttf');
}
@font-face {
    font-family: 'Oswald-Medium';
    src: url('./assets/fonts/oswald/Oswald-Medium.ttf');
}
@font-face {
    font-family: 'Oswald-SemiBold';
    src: url('./assets/fonts/oswald/Oswald-SemiBold.ttf');
}
@font-face {
    font-family: 'Oswald-ExtraLight';
    src: url('./assets/fonts/oswald/Oswald-ExtraLight.ttf');
}
@font-face {
  font-family: 'ZenLoop';
  src: url('./assets/fonts/zenloop/ZenLoop-Regular.ttf');
}
@font-face {
  font-family: 'ZenLoop-Italic';
  src: url('./assets/fonts/zenloop/ZenLoop-Italic.ttf');
}
@font-face {
  font-family: 'ReemKufi';
  src: url('./assets/fonts/reemkufi/ReemKufi-Regular.ttf');
}
@font-face {
  font-family: 'ReemKufi-Bold';
  src: url('./assets/fonts/reemkufi/ReemKufi-Bold.ttf');
}
@font-face {
  font-family: 'ReemKufi-Medium';
  src: url('./assets/fonts/reemkufi/ReemKufi-Medium.ttf');
}
@font-face {
  font-family: 'ReemKufi-SemiBold';
  src: url('./assets/fonts/reemkufi/ReemKufi-SemiBold.ttf');
}

* {
  margin: 0;
  padding: 0;
}

#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin: 0;
}

body::-webkit-scrollbar {
  display: none;
}

body{
  -ms-overflow-style: none;
  scrollbar-width: none;
}
</style>
